#!/usr/bin/env python3

import sys

def encode_plane(plane):
    coded_plane = bytearray([0])
    prev_i = 0
    for i in plane[0:8]:
        coded_plane[0] = (coded_plane[0] << 1) & 0xff
        if prev_i != i:
            coded_plane.append(i)
            prev_i = i
        else:
            coded_plane[0] = coded_plane[0] | 1       
    return coded_plane

prev_tile = None

while True:
    tile = sys.stdin.buffer.read(16)
    if len(tile) != 16:
        if prev_tile:
            sys.stdout.buffer.write(prev_tile)
        else:
            print("Input must be at least 16 bytes.", file=sys.stderr)
        break;
    if prev_tile:
        prev_tile[0] = prev_tile[0] & 0xfe
        sys.stdout.buffer.write(prev_tile)
    prev_tile = encode_plane(tile[0:7] + tile[6:7])

